//v 1.3
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.io.*;

//This class does the actions for when the Autosave button is clicked

public class BackupAutoListener implements ActionListener {

  // This is where the options are retrieved from
  JTextField txtGamePath,txtBackupPath,txtInterval,txtNumberSaves;
  private BackupDomTurn budt1;
  private java.util.Timer t1;
  private boolean booAutoOn = false;
  private JButton butBackupNow, butAutoBackup, butRestoreNow;
  private JLabel lblFeedback;
  private boolean booLabelInit = false;

  public void LinkGUI(JTextField txtNewGamePath, JTextField txtNewBackupPath, JTextField txtNewInterval, JTextField txtNewNumberSaves,
                      JButton butNewBackupNow, JButton butNewAutoBackup, JButton butNewRestoreNow, JLabel lblNewFeedback)
  {
  // Link this class to the other GUI elements
    txtGamePath = txtNewGamePath;
    txtBackupPath= txtNewBackupPath;
    txtNumberSaves= txtNewNumberSaves;
    txtInterval = txtNewInterval;
    butBackupNow = butNewBackupNow;
    butAutoBackup = butNewAutoBackup;
    butRestoreNow = butNewRestoreNow;

    lblFeedback = lblNewFeedback;
    booLabelInit = true;
  }

  // Implementation of ActionListener interface.
  public void actionPerformed(ActionEvent event)
  {
  //Toggle autobackup, and adjust GUI accordingly
    //Either turn auto save on or turn it off
    if (!booAutoOn)
    {
      t1 = new java.util.Timer();
      budt1 = new BackupDomTurn();

      //link the backup class to the necessary GUI items
      budt1.InitializeSavePath(txtGamePath.getText(), txtBackupPath.getText(), (int) ((Integer.parseInt(txtNumberSaves.getText() ) )) );
      budt1.InitializeFeedbackLabel(lblFeedback);

      t1.schedule(budt1, 0, (int) ((Integer.parseInt(txtInterval.getText() ) ) * 1000) );
      butAutoBackup.setText("Cancel Auto");
    }
    else
    {
      t1.cancel();
      butAutoBackup.setText("Auto Backup");
    }

    //Flip it
    booAutoOn = !booAutoOn;

    //While auto is on, lock the buttons and text fields
    butBackupNow.setEnabled(!booAutoOn);
    butRestoreNow.setEnabled(!booAutoOn);

    txtGamePath.setEditable(!booAutoOn);
    txtBackupPath.setEditable(!booAutoOn);
    txtNumberSaves.setEditable(!booAutoOn);
    txtInterval.setEditable(!booAutoOn);

  }

}
